<?php
/**
* Подпрограмма для получения Alexa Rank
*
* @package      seoUtilitiesFiles
* @author       Andrej Panov <ab@cdef.ru>
* @copyright    2009 Andrej Panov
* @license      http://www.opensource.org/licenses/lgpl-license.php LGPL
* @version      1.20111118
* @link         http://a-panov.ru/
* @link         http://a-panov.ru/download/
* @since        2009-09-22
*/
 
/**
* Класс для формирования запроса на получение Alexa Rank
*
* @package  seoUtilitiesClasses
*/
class cAlexaRank {
    /**
    * Получение значения Alexa Rank
    *
    * @param array $murl массив, возвращённый функцией cBase::get()
    * @return int значение Alexa Rank
    */
    static function get($murl) {
        $url = 'http://data.alexa.com/data?cli=10&dat=snbamz&url=' . $murl['host'];
        
        $buf        = file_get_contents($url);
        $xml        = simplexml_load_string($buf);
        $axml       = @json_decode(json_encode($xml),1);
        $alexarank  = isset($axml['SD'][1]['POPULARITY']['@attributes']['TEXT'])
                    ? (int) $axml['SD'][1]['POPULARITY']['@attributes']['TEXT']
                    : '-';
        return $alexarank;
    }
}
