<?php
/**
* Подпрограмма для получения количества найденных упоминаний сайта по Yahoo
*
* @package      seoUtilitiesFiles
* @author       Andrej Panov <ab@cdef.ru>
* @copyright    2010 Andrej Panov
* @license      http://www.opensource.org/licenses/lgpl-license.php LGPL
* @version      1.20111118
* @link         http://a-panov.ru/
* @link         http://a-panov.ru/download/
* @since        2010-07-10
*/
 
/**
* Класс для формирования запроса на получение Яндекс тИЦ
*
* @package  seoUtilitiesClasses
*/
class cBackLinksFromYahoo {
    /**
    * Получение значения тематического индекса цитирования
    *
    * @param array $murl массив, возвращённый функцией cBase::get()
    * @return int количество найденный через Yahoo бэк-линков
    */
    static function get($murl) {
        $num        = 0;
        $search     = 'Inlinks (';
        $search_cnt = strlen($search);
        $url        = 'http://siteexplorer.search.yahoo.com/search?p=' . $murl['host'] .'&bwm=i&bwmo=s&bwmf=s';
        
        $buf = file_get_contents($url);
        
        if ( FALSE !== ($pos1 = strpos($buf, 'Inlinks (')) ) {
            $pos1 += $search_cnt;
            $pos2 = strpos($buf, ')', $pos1);
            $num = substr($buf, $pos1, $pos2 - $pos1);
            $num = preg_replace('![^0-9]!', '', $num);
        }
        
        return (int) $num;
    }
}
