<?php
/**
* Первичная обработкк url-строки
*
* @package      seoUtilitiesFiles
* @author       Andrej Panov <ab@cdef.ru>
* @copyright    2009 Andrej Panov
* @license      http://www.opensource.org/licenses/lgpl-license.php LGPL
* @version      1.20111118
* @link         http://a-panov.ru/
* @link         http://a-panov.ru/download/
* @since        2009-09-22
*/
 
/**
* Класс для разбора url-строки на составляющие части
*
* @package  seoUtilitiesClasses
*/
class cBase {

    /**
    * Возвращает массив с данными о переданном адресе
    *
    * Допустимо задавать как полный адрес, с http://, так и укороченный.
    * Будут проанализированы обра варианта.
    *
    * Существуют национальные домены 3 уровня (например, net.ru), однако
    * в каждой стране они формируются по своему. Поэтому хуизу и им подобным
    * сервисам потребуется самим выделить требуемый домен (чтобы получить
    * данные о домене <i>test.pp.ru</i>, требуется сделать запрос
    * на национальный сервер на вывод информации для домена <i>test.pp.ru</i>,
    * а не для <i>pp.ru</i>).
    * Именно поэтому в данном модуле подобный функционал реализован НЕ БУДЕТ!
    *
    * @param string $adr полный или частичный URL
    * @return array массив со значениями различных частей URL
    */
    static function get($adr) {
        $murl = array();
/*  возможно, позже, анализ запроса будет расширен (не факт!). на текущие плагины это никак не повлияет
    preg_match('!^(([^:/?#]+)://)?(([^:]*)(:(.*))?@)?([a-z\.0-9-]+)(:([0-9]+))?(/[^\?#]+)?(\?([^#]*))?(#(.*))?$!i', $adr, $t);
    $murl['sheme']      = empty($t[2])  ? '' : $t[2];   // протокол
    $murl['user']       = empty($t[4])  ? '' : $t[4];   // имя пользователя
    $murl['pasw']       = empty($t[6])  ? '' : $t[6];   // пароль
    $murl['host']       = empty($t[6])  ? '' : $t[6];   // 
    $murl['port']       = empty($t[9])  ? '' : $t[9];   // 
    $murl['path']       = empty($t[10]) ? '' : $t[10];  // 
    $murl['query']      = empty($t[12]) ? '' : $t[12];  // 
    $murl['fragment']   = empty($t[14]) ? '' : $t[14];  // 
*/
        
        preg_match('!^(([^:/?#]+)://)?([a-z\.0-9-]+)(:([0-9]+))?(/[^\?#]*)?(\?([^#]*))?(#(.*))?$!i', $adr, $t);
        $murl['sheme']  = empty($t[2])  ? 'http' : strtolower($t[2]); // протокол
        $murl['host']   = empty($t[3])  ? ''     : strtolower($t[3]); // адрес
        $murl['port']   = empty($t[5])  ? 0      : (int) $t[5];       // порт
        
        $murl['path']       = empty($t[6])  ? '/': $t[6];   // путь
        $murl['query']      = empty($t[8])  ? '' : $t[8];   // запрос
        $murl['fragment']   = empty($t[10]) ? '' : $t[10];  // 
        
        // если вместо доменного имени задан IP, это нужно как-то отразить
        if (preg_match('!(^[0-9]{1,3}\.){3}[0-9]{1,3}#!', $murl['host'])) {
            $murl['ip']   = $murl['host'];
            $murl['host'] = '';
        } else {
            $domains = explode('.', $murl['host']);
            $murl['domain_level'] = count($domains);
            $murl['domain_list']  = $domains;
            $level = $murl['domain_level'] - 1;
            
            // если поддомены найдены
            if ($murl['domain_level'] > 1) { // определяем корневой домен
                $murl['root_domain'] = $domains[$level];
                $level--;
                
                if ($murl['domain_level'] > 2) {
                    // проверим, не используется ли алиас
                    // алиасы имеет смысл искать только для доменов 3 уровня
                    if (preg_match('!^w(ww|ap)\.!', $murl['host'])) {
                        // алиасами де-факто считаются под-домены с www. и wap.
                        $murl['alias'] = $murl['host'];
                        $murl['host'] = substr($murl['host'], 4);
                    }
                }
            }
        }
        
        if (empty($murl['port'])) {
            // возможно в дальнейшем будет добавлена поддержка ftp и прочие
            switch ($murl['sheme']) {
            default: $murl['port'] = 80;
            }
        }
        
        return $murl;
    }
}
