<?php
/**
* Подпрограмма для получения Яндекс тИЦ
*
* @package      seoUtilitiesFiles
* @author       Andrej Panov <ab@cdef.ru>
* @copyright    2009 Andrej Panov
* @license      http://www.opensource.org/licenses/lgpl-license.php LGPL
* @version      1.20111118
* @link         http://a-panov.ru/
* @link         http://a-panov.ru/download/
* @since        2009-09-22
*/
 
/**
* Класс для формирования запроса на получение Яндекс тИЦ
*
* @package  seoUtilitiesClasses
*/
class cCY {
    /**
    * Получение значения тематического индекса цитирования
    *
    * @param array $murl массив, возвращённый функцией cBase::get()
    * @return int значение тИЦ
    */
    static function get($murl) {
        $host = 'http://' . $murl['host'];
        $url = 'http://bar-navig.yandex.ru/u?show=1&url=' . $host;
        $buf = file_get_contents($url);
        if (empty($buf)) return 0;
        preg_match('/<tcy rang="[^"]*" value="([0-9]+)/', $buf, $t);
        return isset($t[1]) ? (int) $t[1] : 0;
    }
}
